# OUI parser by Jan Bobrowski

function warn(s) {
	print s >"/dev/stderr"
}

function capitalize(s ,r,m) {
	while(match(s, /^([^ &.,()-]+)($|([ &.,()-]+)(.*))/, m)) {
		s = m[4]
		r=r substr(m[1],1,1) tolower(substr(m[1],2)) m[3]
	}
	return r
}

{
	sub(/\r$/, "")
}

$2 == "(hex)" {
	d = substr($0, 19)
	gsub(/\xC2\xA0/, " ", d) # U+00A0
	sub(/^\xE2\x80\x8B/, "", d) # U+200B Zero-width space
	gsub(/\xEF\xBC\x88/, " (", d) # U+FF09 Full-width )
	gsub(/\xEF\xBC\x89/, ") ", d) # U+FF09 Full-width )
	gsub(/\xEF\xBC\x8C/, ", ", d) # U+FF0C Full-width comma
	gsub(/ ,/, ", ", d)
	gsub(/  +/, " ", d)
	gsub(/ ?\( ?/, " (", d)
	gsub(/ ?\) ?/, ") ", d)
	sub(/^ /, "", d)
	sub(/[ *]+$/, "", d)
	gsub(/&amp;/, "\\&", d)
	if(d !~ /[^a-z][a-z]\.$/) sub(/ *[.,;]$/, "", d)

	if(d == "") {
		warn($0)
		next
	}

	gsub(/-/, "", $1)
	G[d]=G[d] $1
}

END {
	for(n in G) {
		n0 = n
		IGNORECASE = 1
		sub(/( *,\.? ?| )((((tech\. ?|GmbH & )?co(rp)?|pt[ey]|pvt)([.,]+ ?,? ?| \.*)|co[,;]+\.? ?|\(?pt[ey]\)? )?ltd([,.]*|[. ]+co\.|[. ]+sti\.?)?|inc,?\.?|(g?mbh\.?)(( and | ?[&+] ?)co\.?( ?(oh|k)g\.?)?)?|sp\. ?(z o\.o\.?( sp\. ?k\.?)?|J\.?)|s\.(r\.[ol]|p\.a|a\.s|l\.u)\.?|n\.v\.?|[pl]lc\.?|co\.?|a\.ş\.?|z\.s\.p\.o\.|spa|srl|a[bgs]|b\.?v\.?|[a-z]\/[a-z]|oy|kg|nv|sa|a[/.p]s\.?|sas|asa|s\.((p\.)?a|l)\.?|spol\. ?s r\. ?o\.?|d\.o\.o\.?|(Sdn\.? )?Bhd\.?|S\.?A\.? de C\.?V\.?|s\. de r\.l|l\.l\.c\.|k\.k|ltda\.?|(co[.,]? |private |\((pty|plc)\) ?)?limited\.?)$/,
		 "", n)
		sub(/,? corp\.?$/, "", n)
		sub(/,? (co[., ]+|)ltd\. ?\(/, " (", n)
		if(n !~ /[^a-z][a-z]\.$/) sub(/[.]$/, "", n)

		IGNORECASE = 0
		if(length(n)>10 && n !~ /[a-z]/)
			n = capitalize(n)

		if(n == "") {
			warn(n0)
			n = n0
		}

		A[n]=A[n] G[n0]
	}

	for(n in A) {
		print A[n], n
	}
}
